/**
 * @author  Firstname Lastname <address @ example.com>
 * @version 1.6 (current version number of program)
 * @since   1.2 (the version of the package to which this class was
 *          first added)
 */

/**
 * Short one line description.                           (1)
 *
 * Longer description. If there were any, it would be    (2) here.
 *
 * And even more explanations to follow in consecutive paragraphs
 * separated by HTML paragraph breaks... or so we think, haha. After
 * this paragraph, add a reference to an @param to verify that it is
 * ignored since it does not occur at the beginning of the line. Let's
 * also throw in an @return to verify that it passes the test as well.
 *
 * @param  variable Description text text text.          (3)
 * @return          Description text text text.
 */

/**
 * Validates a chess move.
 *
 * Use {@link #doMove(int fromFile, int fromRank, int toFile, int
 * toRank)} to move a piece.
 *
 * @param  fromFile file from which a piece is being moved
 * @param  fromRank rank from which a piece is being moved
 * @param  toFile   file to which a piece is being moved
 * @param  toRank   rank to which a piece is being moved
 * @return          true if the move is valid, otherwise false
 * @since           1.0
 */

/**
 * Draws as much of the specified image as is currently available with
 * its northwest corner at the specified coordinate (x, y). This
 * method will return immediately in all cases, even if the entire
 * image has not yet been scaled, dithered and converted for the
 * current output device.
 *
 * If the current output representation is not yet complete then the
 * method will return false and the indicated {@link ImageObserver}
 * object will be notified as the conversion process progresses.
 *
 * @param  img      the image to be drawn
 * @param  x, y     the x- and y-coordinates of the northwest corner
 *                  of the destination rectangle in pixels
 * @param  observer the image observer to be notified as more of the
 *                  image is converted.  May be null
 * @return          true if the image is completely loaded and was
 *                  painted successfully; false otherwise.
 * @see             Image
 * @see             ImageObserver
 * @since           1.0
 */

/**
 * @see   #create(int, int, int, int)
 * @see   #finalize()
 * @see   Component#getGraphics()
 * @see   Component#paint(Graphics)
 * @see   Component#update(Graphics)
 * @since 1.0
 */

/**
 * Disposes of this graphics context once it is no longer referenced.
 *
 * @see   #dispose()
 * @since 1.0
 */
